﻿package  {
	
	import flash.media.Sound;
	import flash.events.SamplesCallbackEvent;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;

	
	public class OTO extends Sound{
		
		static public const TWELEVE_TONE_SCALE:Array =[220,
													233.08,
													246.94,
													261.63,
													277.18,
													293.67,
													311.13,
													329.63,
													349.23,
													369.99,
													392,
													415.31,
													]
 
		
		static public const MUTE:Number	= 0;
		
		static public const DO:Number	= TWELEVE_TONE_SCALE[0];
		static public const DOs:Number	= TWELEVE_TONE_SCALE[1];
		static public const RE:Number	= TWELEVE_TONE_SCALE[2];
		static public const REs:Number	= TWELEVE_TONE_SCALE[3];
		static public const MI:Number	= TWELEVE_TONE_SCALE[4];
		static public const FA:Number	= TWELEVE_TONE_SCALE[5];
		static public const FAs:Number	= TWELEVE_TONE_SCALE[6];
		static public const SO:Number	= TWELEVE_TONE_SCALE[7];
		static public const SOs:Number	= TWELEVE_TONE_SCALE[8];
		static public const RA:Number	= TWELEVE_TONE_SCALE[9];
		static public const RAs:Number	= TWELEVE_TONE_SCALE[10];
		static public const SI:Number	= TWELEVE_TONE_SCALE[11];

		static public const A:Number	= TWELEVE_TONE_SCALE[0];
		static public const B:Number	= TWELEVE_TONE_SCALE[1];
		static public const H:Number	= TWELEVE_TONE_SCALE[2];
		static public const C:Number	= TWELEVE_TONE_SCALE[3];
		static public const Cs:Number	= TWELEVE_TONE_SCALE[4];
		static public const D:Number	= TWELEVE_TONE_SCALE[5];
		static public const Ds:Number	= TWELEVE_TONE_SCALE[6];
		static public const E:Number	= TWELEVE_TONE_SCALE[7];
		static public const F:Number	= TWELEVE_TONE_SCALE[8];
		static public const Fs:Number	= TWELEVE_TONE_SCALE[9];
		static public const G:Number	= TWELEVE_TONE_SCALE[10];
		static public const Gs:Number	= TWELEVE_TONE_SCALE[11];
		

		
		private const SAMPLEING_RATE:Number = 44100
		
		private var refreshRate:uint = 4410
		private var herts:Number = 220
		private var _frequency:Number = 220
		private var _volume:Number = .5
		
		private var ampEnd:Number =0
		
		public function OTO() {
			init()	
		}
		
		private function init():void{
					
			this.addEventListener("samplesCallback",sineWavGenerator);  
			
		}
		public function start(toneScale:Number = 220):SoundChannel{
			this.frequency = toneScale
			return this.play()
		}
		private	function sineWavGenerator(event:SamplesCallbackEvent):void {  
				
			var rate:Number = SAMPLEING_RATE
			var refreshRate:Number = this.refreshRate
			
			var amp:Number
			var freq:Number = (Math.PI * 2) * frequency / 44100;
			
			var volume:Number = this.volume
											
			for ( var c:int=1; c <= refreshRate; c++ ) {  
					
				amp = (c * freq) + ampEnd 
				
				var sample:Number = Math.sin(amp) * volume
				   
				this.samplesCallbackData.writeFloat(sample);      
				this.samplesCallbackData.writeFloat(sample);    
				
			}
			ampEnd = amp
		}  
		
		public function get frequency():Number { return _frequency; }
		public function set frequency(value:Number):void {
			_frequency = value;
		}
		
		public function get volume():Number { return _volume; }		
		public function set volume(value:Number):void {
			_volume = value;
		}


		
	}
	
}