﻿package  {
	
	import flash.display.Sprite;
	import flash.events.*;
	import flash.media.Sound;
	import caurina.transitions.Tweener
	import com.kappaLab.utils.WaveViewer

	[SWF (frameRate="60")]
	public class ToneScale1 extends Sprite {
		
		private var waveViewer:WaveViewer
		private var playbtn:PlayButton
		
		public function ToneScale1() {
			
			init();
			
		}
		
		private function init():void {
			
			playbtn = new PlayButton()
			addChild(playbtn)
			playbtn.onPress = makeSound
			
			waveViewer = new WaveViewer(this, 4, 300);		
					

			
		}
		private function makeSound():void{
			
			var oto:OTO = new OTO()
			
			oto.start(OTO.MUTE);
			oto.volume = .5
			oto.frequency = OTO.DO
			
			Tweener.addTween(oto, {frequency:OTO.RE, time:0, delay:.5,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.MI, time:0, delay:1,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.RE, time:0, delay:2,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.DO, time:0, delay:2.5, transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.MUTE, time:0, delay:3,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.DO, time:0, delay:3.5, transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.RE, time:0, delay:4,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.MI, time:0, delay:4.5,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.RE, time:0, delay:5,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.DO, time:0, delay:5.5, transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.RE, time:0, delay:6,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.MI, time:0, delay:7.5,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.RE, time:0, delay:7.7,transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.DO, time:0, delay:7.9, transition:"linear"});
			Tweener.addTween(oto, {frequency:OTO.MUTE, time:0, delay:8.3, transition:"linear"});
			
			addEventListener(Event.ENTER_FRAME,onEnterFrame)
			
		}
		private function onEnterFrame(e:Event):void{
			waveViewer.buildWaveFromSound(3,300)
		}
		
	}
	
}